# we can define our own exceptions
class NoData(Exception):
    pass


temperature_data = [
    ("2020-03-22", 12.3),
    ("2020-03-23", 13.2),
    ("2020-03-24", 11.3),
    ("2020-03-25", 15.0),
    ("2020-03-26", 16.9),
    ("2020-03-27", 10.4),
    ("2020-03-28", 17.3),
    ("2020-03-29", 15.2),
    ("2020-03-30", 16.9),
]


def get_temp(date):
    dates, temps = zip(*temperature_data)
    if date not in dates:
        raise NoData  # we raise our own exception

    temp = None
    for i, d in enumerate(dates):
        if d == date:
            temp = temps[i]
            break
    return temp


def get_dates(temp):
    dates, temps = zip(*temperature_data)
    if temp not in temps:
        raise NoData  # we raise our own exception

    matching_dates = []
    for i, t in enumerate(temps):
        if t == temp:
            matching_dates.append(dates[i])
    return matching_dates


choice = input("Do you want to specify a date [d] or a temperature [t]? ")
try:
    if choice == "d":
        date = input("Date: ")
        temp = get_temp(date)
        print(f"The temperature on {date} was {temp} °C.")
    elif choice == "t":
        temp = input("Temperature: ")
        dates = get_dates(float(temp))
        print(f"The temperature was {temp} on the following days:")
        for date in dates:
            print(date)
except NoData:  # we catch any NoData exception here
    print("There is no data that matches your request.")
